/* INFOH302 - TP04-05 - Exercice 5: Command */

public class MoveCommand implements Command {

	private int n;
	private int posy;
	private int posx;
	private Park park;

	public MoveCommand(int n, int posy, int posx, Park park) {
		this.n = n;
		this.posy = posy;
		this.posx = posx;
		this.park = park;
	}

	public void execute() throws CommandException
	{
		Wanderer w = park.getWanderer(n);
		if(w==null) throw new CommandException("Wanderer does not exists");
		else if(w.move_allowed(posx, posy, park.WIDTH, park.HEIGTH))
				w.move(posx, posy);
		else
			throw new CommandException("Move out of bounds");
	}

	public void undo() {
		Wanderer w = park.getWanderer(n);
		w.move(-posx, -posy);
	}

	public String toString() {
		return "move "+n+" "+posx+" "+posy;
	}

}
