/* INFOH302 - TP04-05 - Exercice 5: Command 
*
*  Voici le code d'une application console permettant de 
*   - Faire circuler un des promeneurs 
*   - Ajouter de nouveaux promeneurs
* 
*   1. Modifier ce code pour permettre des undos multiples.
*   2. Modifier ce code pour permettre des redos multiples.
*   3. Modifier ce code pour ajouter une commande imprimant toutes les
*      commandes effectues jusquՈ present (et non annules) avec un timestamp.
*   4. Ajouter une commande pour retirer tous les promeneurs
*/

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class ParkApplication {
	private Park park = new Park();

	private String message = "Welcome to ParkGarden";  // message  afficher  l'utilisateur au draw()
	private Invoker invoker = new Invoker();

    public void run() throws IOException {
        String line="";
		int n, posx, posy;
		BufferedReader input = new BufferedReader(
						new InputStreamReader(System.in));
		while(true) {
			System.out.println(message);
			message = ""; // reset message
			try {
	            line = input.readLine();
				if(line.startsWith("stop")) break;
				String[]  command = line.split(" ");
	            if(command.length == 3 && command[0].equals("add")) {
	            	posx = Integer.parseInt(command[1]);
	                posy = Integer.parseInt(command[2]);
					executeAddCommand(posx,posy);
	            } else if(command.length == 4 && command[0].equals("move")) {
	                n = Integer.parseInt(command[1]);
	                posx = Integer.parseInt(command[2]);
	                posy = Integer.parseInt(command[3]);
					executeMoveCommand(n, posx, posy);
	            } else if(command.length == 1 && command[0].equals("undo")) {
	            	this.invoker.undo(); // not an undoable command.
	            } else if(command.length == 1 && command[0].equals("redo")) {
	            	this.invoker.redo(); // not an undoable command.
	            } else if(command.length == 1 && command[0].equals("print_commands")) {
	            	this.printCommands(); // not an undoable command.
	            } else {
					this.message ="Unrecognized command: "+line;
	            }
			} catch (CommandException e) {
				this.message = e.getMessage();
			}catch (Exception e) {
				this.message = "Commands are : \n "
					+"  add x y (where x and y are the positions),\n"
					+"  move n x y (where n is the index of the traveler and x,y the movement offset),\n"
					+"  undo"
					+"  redo"
					+"  print_commands"
					+"  stop\n";
			}
			park.draw();
		}
    }

	private void executeAddCommand(int posx, int posy) throws CommandException {
        Command commandObject = new AddCommand(posx, posy, park);
    	invoker.store(commandObject);
	}
	
	private void executeMoveCommand(int n, int posx, int posy) throws CommandException {
        Command commandObject = new MoveCommand(n, posx, posy, park);
    	invoker.store(commandObject);
	}

	private void printCommands() {
		this.message = invoker.commandsToString();
	}
    public static void main(String[] args) throws Exception {
        ParkApplication pa = new ParkApplication();
        pa.run();
     }
}
